Column Header Fit Mode

Some layouts may require thin column widths but contain longer column header data that must fully be displayed in the view.

SpreadJS has several different modes to support this scenario - normal mode, vertical mode, and stacked mode.

Description
app.js
index.html
styles.css
Copy to CodeMine

Tablesheet supports three type to adjust the column header fit mode:

  1. normal(default)
  2. vertical
  3. stack

Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner.

interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
    headerFit?: "normal" | "vertical" | "stack" // the column header fit mode, default is normal
}

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
//add custom view
var myView = orderTable.addView("myView", [
    {value: 'orderId',caption: "OrderId", width: 45, headerFit: "stack"},
    {value: 'customerId', caption: "CustomerName", width: 50,  headerFit: "stack"},
    {value: 'employeeId', caption: "EmployeeId", width: 16, headerFit: "stack"},
    {value: 'orderDate', caption: "orderDate", width: 136, },
    {value: 'requiredDate', caption: "requiredDate", width: 136, headerFit: "vertical"},
    {value: 'shippedDate', caption: "ShippedDate", width: 136, headerFit: "normal"},
    {value: 'shipVia', caption: "ShipVia", width: 16, headerFit: "stack"},
    {value: 'freight', caption: "Freight", width: 45, headerFit: "stack"},
    {value: 'shipName', caption: "ShipName", width: 100, headerFit: "normal"}
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
Tablesheet supports three type to adjust the column header fit mode: normal(default) vertical stack Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner. This is the sample code.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); }; function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); //add product table var productTable = dataManager.addTable("productTable", { remote: { read: { url: baseApiUrl + "/Product" } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var myView = productTable.addView("myView", [ { value: "Id", caption: "ID", width: 46, headerFit: "vertical" }, { value: "ProductName", caption: "Name", width: 220 }, { value: "QuantityPerUnit", caption: "Quantity Per Unit", width: 140, headerFit: "stack" }, { value: "UnitPrice", caption: "Unit Price", width: 45, headerFit: "stack", headerStyle: { backColor : "#F7A711", foreColor:"white", borderLeft: { color: "#367fc9", style: "thin" }, borderTop: { color: "#367fc9", style: "thick" }, borderRight: { color: "#367fc9", style: "thin" }, borderBottom: { color: "#367fc9", style: "thin" } }}, { value: "UnitsInStock", caption: "Units In Stock", width: 40, headerFit: "stack" }, { value: "UnitsOnOrder", caption: "Units On Order", width: 40, headerFit: "stack", headerStyle: { backColor : "#F7A711"}}, { value: "ReorderLevel", caption: "Reorder Level", width: 140, headerStyle: { borderLeft: { color: "black", style: "thin" }, borderTop: { color: "black", style: "thin" }, borderRight: { color: "black", style: "thin" }, borderBottom: { color: "black", style: "thin" }, } }, { value: "Discontinued", headerFit: "vertical", width: 70} ]); myView.fetch().then(function() { sheet.setDataView(myView); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="optionContainer" class="optionContainer"> </div> </div> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; }

Tablesheet supports three type to adjust the column header fit mode:
normal(default)
vertical
stack
Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner.
This is the sample code.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID", width: 46, headerFit: "vertical" },
{ value: "ProductName", caption: "Name", width: 220 },
{ value: "QuantityPerUnit", caption: "Quantity Per Unit", width: 140, headerFit: "stack" },
{
value: "UnitPrice", caption: "Unit Price", width: 45, headerFit: "stack", headerStyle: {
backColor: "#F7A711",
foreColor: "white",
borderLeft: {
color: "#367fc9",
style: "thin"
},
borderTop: {
color: "#367fc9",
style: "thick"
},
borderRight: {
color: "#367fc9",
style: "thin"
},
borderBottom: {
color: "#367fc9",
style: "thin"
}
}
},
{ value: "UnitsInStock", caption: "Units In Stock", width: 40, headerFit: "stack" },
{
value: "UnitsOnOrder", caption: "Units On Order", width: 40, headerFit: "stack", headerStyle: {
backColor: "#F7A711"
}
},
{
value: "ReorderLevel", caption: "Reorder Level", width: 140, headerStyle: {
borderLeft: {
color: "black",
style: "thin"
},
borderTop: {
color: "black",
style: "thin"
},
borderRight: {
color: "black",
style: "thin"
},
borderBottom: {
color: "black",
style: "thin"
},
}
},
{ value: "Discontinued", headerFit: "vertical", width: 70 }
]);
myView.fetch().then(function () {
sheet.setDataView(myView);
});
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add product table
var productTable = dataManager.addTable("productTable", {
remote: {
read: {
url: baseApiUrl + "/Product"
}
}
});
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var myView = productTable.addView("myView", [
{ value: "Id", caption: "ID", width: 46, headerFit: "vertical" },
{ value: "ProductName", caption: "Name", width: 220 },
{ value: "QuantityPerUnit", caption: "Quantity Per Unit", width: 140, headerFit: "stack" },
{ value: "UnitPrice", caption: "Unit Price", width: 45, headerFit: "stack", headerStyle: {
backColor : "#F7A711",
foreColor:"white",
borderLeft: {
color: "#367fc9",
style: "thin"
},
borderTop: {
color: "#367fc9",
style: "thick"
},
borderRight: {
color: "#367fc9",
style: "thin"
},
borderBottom: {
color: "#367fc9",
style: "thin"
}
}},
{ value: "UnitsInStock", caption: "Units In Stock", width: 40, headerFit: "stack" },
{ value: "UnitsOnOrder", caption: "Units On Order", width: 40, headerFit: "stack", headerStyle: {
backColor : "#F7A711"}},
{ value: "ReorderLevel", caption: "Reorder Level", width: 140, headerStyle: {
borderLeft: {
color: "black",
style: "thin"
},
borderTop: {
color: "black",
style: "thin"
},
borderRight: {
color: "black",
style: "thin"
},
borderBottom: {
color: "black",
style: "thin"
},
} },
{ value: "Discontinued", headerFit: "vertical", width: 70}
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Column Header Fit Mode

Some layouts may require thin column widths but contain longer column header data that must fully be displayed in the view.

SpreadJS has several different modes to support this scenario - normal mode, vertical mode, and stacked mode.

Description
app.vue
index.html
Copy to CodeMine

Tablesheet supports three type to adjust the column header fit mode:

  1. normal(default)
  2. vertical
  3. stack

Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner.

interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
    headerFit?: "normal" | "vertical" | "stack" // the column header fit mode, default is normal
}

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
//add custom view
var myView = orderTable.addView("myView", [
    {value: 'orderId',caption: "OrderId", width: 45, headerFit: "stack"},
    {value: 'customerId', caption: "CustomerName", width: 50,  headerFit: "stack"},
    {value: 'employeeId', caption: "EmployeeId", width: 16, headerFit: "stack"},
    {value: 'orderDate', caption: "orderDate", width: 136, },
    {value: 'requiredDate', caption: "requiredDate", width: 136, headerFit: "vertical"},
    {value: 'shippedDate', caption: "ShippedDate", width: 136, headerFit: "normal"},
    {value: 'shipVia', caption: "ShipVia", width: 16, headerFit: "stack"},
    {value: 'freight', caption: "Freight", width: 45, headerFit: "stack"},
    {value: 'shipName', caption: "ShipName", width: 100, headerFit: "normal"}
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
Tablesheet supports three type to adjust the column header fit mode: normal(default) vertical stack Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner. This is the sample code.
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; const spreadRef = ref(null); function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); //add product table var productTable = dataManager.addTable("productTable", { remote: { read: { url: baseApiUrl + "/Product" } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var myView = productTable.addView("myView", [ { value: "Id", caption: "ID", width: 46, headerFit: "vertical" }, { value: "ProductName", caption: "Name", width: 220 }, { value: "QuantityPerUnit", caption: "Quantity Per Unit", width: 140, headerFit: "stack" }, { value: "UnitPrice", caption: "Unit Price", width: 45, headerFit: "stack", headerStyle: { backColor: "#F7A711", foreColor: "white", borderLeft: { color: "#367fc9", style: "thin" }, borderTop: { color: "#367fc9", style: "thick" }, borderRight: { color: "#367fc9", style: "thin" }, borderBottom: { color: "#367fc9", style: "thin" } } }, { value: "UnitsInStock", caption: "Units In Stock", width: 40, headerFit: "stack" }, { value: "UnitsOnOrder", caption: "Units On Order", width: 40, headerFit: "stack", headerStyle: { backColor: "#F7A711" } }, { value: "ReorderLevel", caption: "Reorder Level", width: 140, headerStyle: { borderLeft: { color: "black", style: "thin" }, borderTop: { color: "black", style: "thin" }, borderRight: { color: "black", style: "thin" }, borderBottom: { color: "black", style: "thin" }, } }, { value: "Discontinued", headerFit: "vertical", width: 70 } ]); myView.fetch().then(function () { sheet.setDataView(myView); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Column Header Fit Mode

Some layouts may require thin column widths but contain longer column header data that must fully be displayed in the view.

SpreadJS has several different modes to support this scenario - normal mode, vertical mode, and stacked mode.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

Tablesheet supports three type to adjust the column header fit mode:

  1. normal(default)
  2. vertical
  3. stack

Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner.

interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
    headerFit?: "normal" | "vertical" | "stack" // the column header fit mode, default is normal
}

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
//add custom view
var myView = orderTable.addView("myView", [
    {value: 'orderId',caption: "OrderId", width: 45, headerFit: "stack"},
    {value: 'customerId', caption: "CustomerName", width: 50,  headerFit: "stack"},
    {value: 'employeeId', caption: "EmployeeId", width: 16, headerFit: "stack"},
    {value: 'orderDate', caption: "orderDate", width: 136, },
    {value: 'requiredDate', caption: "requiredDate", width: 136, headerFit: "vertical"},
    {value: 'shippedDate', caption: "ShippedDate", width: 136, headerFit: "normal"},
    {value: 'shipVia', caption: "ShipVia", width: 16, headerFit: "stack"},
    {value: 'freight', caption: "Freight", width: 45, headerFit: "stack"},
    {value: 'shipName', caption: "ShipName", width: 100, headerFit: "normal"}
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
Tablesheet supports three type to adjust the column header fit mode: normal(default) vertical stack Users can set the column header fit mode for the specified column in a tablesheet view in order to display the header and viewport data in a suitable manner. This is the sample code.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { let spread = $event.spread; spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); //add product table var productTable = dataManager.addTable("productTable", { remote: { read: { url: baseApiUrl + "/Product" } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var myView = productTable.addView("myView", [ { value: "Id", caption: "ID", width: 46, headerFit: "vertical" }, { value: "ProductName", caption: "Name", width: 220 }, { value: "QuantityPerUnit", caption: "Quantity Per Unit", width: 140, headerFit: "stack" }, { value: "UnitPrice", caption: "Unit Price", width: 45, headerFit: "stack", headerStyle: { backColor : "#F7A711", foreColor:"white", borderLeft: { color: "#367fc9", style: "thin" }, borderTop: { color: "#367fc9", style: "thick" }, borderRight: { color: "#367fc9", style: "thin" }, borderBottom: { color: "#367fc9", style: "thin" } }}, { value: "UnitsInStock", caption: "Units In Stock", width: 40, headerFit: "stack" }, { value: "UnitsOnOrder", caption: "Units On Order", width: 40, headerFit: "stack", headerStyle: { backColor : "#F7A711"}}, { value: "ReorderLevel", caption: "Reorder Level", width: 140, headerStyle: { borderLeft: { color: "black", style: "thin" }, borderTop: { color: "black", style: "thin" }, borderRight: { color: "black", style: "thin" }, borderBottom: { color: "black", style: "thin" }, } }, { value: "Discontinued", headerFit: "vertical", width: 70} ]); myView.fetch().then(function() { sheet.setDataView(myView); }); spread.resumePaint(); } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> </div>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);